<?php

Namespace Core\Utils;

final class Phone{

    private static $CaPhoneAreaCodes = array(
        204 => 204,
        226 => 226,
        236 => 236,
        249 => 249,
        250 => 250,
        289 => 289,
        306 => 306,
        343 => 343,
        365 => 365,
        367 => 367,
        403 => 403,
        416 => 416,
        418 => 418,
        431 => 431,
        437 => 437,
        438 => 438,
        450 => 450,
        506 => 506,
        514 => 514,
        519 => 519,
        548 => 548,
        579 => 579,
        581 => 581,
        587 => 587,
        604 => 604,
        613 => 613,
        639 => 639,
        647 => 647,
        705 => 705,
        709 => 709,
        778 => 778,
        780 => 780,
        782 => 782,
        807 => 807,
        819 => 819,
        825 => 825,
        867 => 867,
        873 => 873,
        902 => 902,
        905 => 905,
    );

    private static $USPhoneAreaCodes = array(
        205 => 205,
        251 => 251,
        256 => 256,
        334 => 334,
        938 => 938,
        907 => 907,
        480 => 480,
        520 => 520,
        602 => 602,
        623 => 623,
        928 => 928,
        479 => 479,
        501 => 501,
        870 => 870,
        209 => 209,
        213 => 213,
        279 => 279,
        310 => 310,
        323 => 323,
        408 => 408,
        415 => 415,
        424 => 424,
        442 => 442,
        510 => 510,
        530 => 530,
        559 => 559,
        562 => 562,
        619 => 619,
        626 => 626,
        628 => 628,
        650 => 650,
        657 => 657,
        661 => 661,
        669 => 669,
        707 => 707,
        714 => 714,
        747 => 747,
        760 => 760,
        805 => 805,
        818 => 818,
        820 => 820,
        831 => 831,
        858 => 858,
        909 => 909,
        916 => 916,
        925 => 925,
        949 => 949,
        951 => 951,
        303 => 303,
        719 => 719,
        720 => 720,
        970 => 970,
        203 => 203,
        475 => 475,
        860 => 860,
        959 => 959,
        302 => 302,
        239 => 239,
        305 => 305,
        321 => 321,
        352 => 352,
        386 => 386,
        407 => 407,
        561 => 561,
        727 => 727,
        754 => 754,
        772 => 772,
        786 => 786,
        813 => 813,
        850 => 850,
        863 => 863,
        904 => 904,
        941 => 941,
        954 => 954,
        229 => 229,
        404 => 404,
        470 => 470,
        478 => 478,
        678 => 678,
        706 => 706,
        762 => 762,
        770 => 770,
        912 => 912,
        808 => 808,
        208 => 208,
        986 => 986,
        217 => 217,
        224 => 224,
        309 => 309,
        312 => 312,
        331 => 331,
        618 => 618,
        630 => 630,
        708 => 708,
        773 => 773,
        779 => 779,
        815 => 815,
        847 => 847,
        872 => 872,
        219 => 219,
        260 => 260,
        317 => 317,
        463 => 463,
        574 => 574,
        765 => 765,
        812 => 812,
        930 => 930,
        319 => 319,
        515 => 515,
        563 => 563,
        641 => 641,
        712 => 712,
        316 => 316,
        620 => 620,
        785 => 785,
        913 => 913,
        270 => 270,
        364 => 364,
        502 => 502,
        606 => 606,
        859 => 859,
        225 => 225,
        318 => 318,
        337 => 337,
        504 => 504,
        985 => 985,
        207 => 207,
        240 => 240,
        301 => 301,
        410 => 410,
        443 => 443,
        667 => 667,
        339 => 339,
        351 => 351,
        413 => 413,
        508 => 508,
        617 => 617,
        774 => 774,
        781 => 781,
        857 => 857,
        978 => 978,
        231 => 231,
        248 => 248,
        269 => 269,
        313 => 313,
        517 => 517,
        586 => 586,
        616 => 616,
        734 => 734,
        810 => 810,
        906 => 906,
        947 => 947,
        989 => 989,
        218 => 218,
        320 => 320,
        507 => 507,
        612 => 612,
        651 => 651,
        763 => 763,
        952 => 952,
        228 => 228,
        601 => 601,
        662 => 662,
        769 => 769,
        314 => 314,
        417 => 417,
        573 => 573,
        636 => 636,
        660 => 660,
        816 => 816,
        406 => 406,
        308 => 308,
        402 => 402,
        531 => 531,
        702 => 702,
        725 => 725,
        775 => 775,
        603 => 603,
        201 => 201,
        551 => 551,
        609 => 609,
        640 => 640,
        732 => 732,
        848 => 848,
        856 => 856,
        862 => 862,
        908 => 908,
        973 => 973,
        505 => 505,
        575 => 575,
        212 => 212,
        315 => 315,
        332 => 332,
        347 => 347,
        516 => 516,
        518 => 518,
        585 => 585,
        607 => 607,
        631 => 631,
        646 => 646,
        680 => 680,
        716 => 716,
        718 => 718,
        838 => 838,
        845 => 845,
        914 => 914,
        917 => 917,
        929 => 929,
        934 => 934,
        252 => 252,
        336 => 336,
        704 => 704,
        743 => 743,
        828 => 828,
        910 => 910,
        919 => 919,
        980 => 980,
        984 => 984,
        701 => 701,
        216 => 216,
        220 => 220,
        234 => 234,
        330 => 330,
        380 => 380,
        419 => 419,
        440 => 440,
        513 => 513,
        567 => 567,
        614 => 614,
        740 => 740,
        937 => 937,
        405 => 405,
        539 => 539,
        580 => 580,
        918 => 918,
        458 => 458,
        503 => 503,
        541 => 541,
        971 => 971,
        215 => 215,
        223 => 223,
        267 => 267,
        272 => 272,
        412 => 412,
        445 => 445,
        484 => 484,
        570 => 570,
        610 => 610,
        717 => 717,
        724 => 724,
        814 => 814,
        878 => 878,
        401 => 401,
        803 => 803,
        843 => 843,
        854 => 854,
        864 => 864,
        605 => 605,
        423 => 423,
        615 => 615,
        629 => 629,
        731 => 731,
        865 => 865,
        901 => 901,
        931 => 931,
        210 => 210,
        214 => 214,
        254 => 254,
        281 => 281,
        325 => 325,
        346 => 346,
        361 => 361,
        409 => 409,
        430 => 430,
        432 => 432,
        469 => 469,
        512 => 512,
        682 => 682,
        713 => 713,
        726 => 726,
        737 => 737,
        806 => 806,
        817 => 817,
        830 => 830,
        832 => 832,
        903 => 903,
        915 => 915,
        936 => 936,
        940 => 940,
        956 => 956,
        972 => 972,
        979 => 979,
        385 => 385,
        435 => 435,
        801 => 801,
        802 => 802,
        276 => 276,
        434 => 434,
        540 => 540,
        571 => 571,
        703 => 703,
        757 => 757,
        804 => 804,
        206 => 206,
        253 => 253,
        360 => 360,
        425 => 425,
        509 => 509,
        564 => 564,
        202 => 202,
        304 => 304,
        681 => 681,
        262 => 262,
        414 => 414,
        534 => 534,
        608 => 608,
        715 => 715,
        920 => 920,
        307 => 307,
    );

    /**
     * @param $phoneNumber
     * @return string
     */
    public static function getCountryIso($phoneNumber) {
        $areCode = (int) substr($phoneNumber,0,3);
        if (!empty(self::$CaPhoneAreaCodes[$areCode])){
            return 'ca';
        }elseif (!empty(self::$USPhoneAreaCodes[$areCode])){
            return 'us';
        }

        return '';
    }

    /**
     * @param $phoneNumber
     * @return string
     */
    public static function getCountryCode($phoneNumber) {
        $areCode = (int) substr($phoneNumber,0,3);
        if (!empty(self::$CaPhoneAreaCodes[$areCode]) || !empty(self::$USPhoneAreaCodes[$areCode])){
            return '1';
        }
        return '';
    }
}